#include "dxstdafx.h"
#include "resource.h"
#include "texturemanager.h"
#include "meshmanager.h"
#include "particlemanager.h"
#include "particlesystem.h"
#include "global.h"

//CMMParticleSystem* g_ps = NULL;
CMMMesh* Ship = NULL;
float eTime = 0.0f;

void CALLBACK InitParticle( CMMParticleSystem* PSYSTEM, int PARTICLEINDEX, bool FIRSTTIME )
{
	D3DVECTOR pos;
	pos.x = 0.0f;
	pos.y = 0.0f;
	pos.z = 0.0f;
	D3DCOLOR col = 0xffffffff;
	PSYSTEM->GetParticle( PARTICLEINDEX )->SetPosition( pos );
	PSYSTEM->GetParticle( PARTICLEINDEX )->SetColor( col );
};

bool CALLBACK IsParticleAlive( CMMParticleSystem* PSYSTEM, int PARTICLEINDEX )
{
	return true;
};

void CALLBACK UpdateParticle( CMMParticleSystem* PSYSTEM, int PARTICLEINDEX )
{

};

void CALLBACK OnFrameRender( IDirect3DDevice9* pd3dDevice, double fTime, float fElapsedTime );
HRESULT CALLBACK OnCreateDevice( IDirect3DDevice9* pd3dDevice, const D3DSURFACE_DESC* pBackBufferSurfaceDesc );
void CALLBACK KeyboardProc( UINT nChar, bool bKeyDown, bool bAltDown );
void InitApp();
void DoneApp();

INT WINAPI WinMain( HINSTANCE, HINSTANCE, LPSTR, int )
{
    DXUTSetCallbackDeviceCreated( OnCreateDevice );
    DXUTSetCallbackFrameRender( OnFrameRender );
	DXUTSetCallbackKeyboard( KeyboardProc );

    DXUTSetCursorSettings( true, true );

    InitApp();

    DXUTInit( true, true, true );
    DXUTCreateWindow( L"FirstGame" );
    DXUTCreateDevice( D3DADAPTER_DEFAULT, true, 640, 480, NULL, NULL );

	DXUTMainLoop();

	DoneApp();

    return DXUTGetExitCode();
}

void InitApp()
{
	InitEngine();
//	g_ps = Particles::GetParticleManager()->CreateParticleSystem();
	Ship = Meshes::GetMeshManager()->CreateMeshObject( MESH_SIMPLE );
}

void DoneApp()
{
	DoneEngine();
}

void CALLBACK OnFrameRender( IDirect3DDevice9* pd3dDevice, double fTime, float fElapsedTime )
{
	pd3dDevice->Clear(0, NULL, D3DCLEAR_TARGET | D3DCLEAR_ZBUFFER, D3DCOLOR_ARGB(0, 10, 10, 10), 1.0f, 0);

//	g_ps->Update();

	if( SUCCEEDED( pd3dDevice->BeginScene() ) )
    {
//		g_ps->Draw( pd3dDevice, D3DXVECTOR3( 0.0f, 0.0f,-3.0f ), D3DXVECTOR3( 0.0f, 0.0f, 0.0f ) );
		Ship->DrawMesh( pd3dDevice );
		pd3dDevice->EndScene();
		pd3dDevice->Present( NULL, NULL, NULL, NULL );
	}
}

HRESULT CALLBACK OnCreateDevice( IDirect3DDevice9* pd3dDevice, const D3DSURFACE_DESC* pBackBufferSurfaceDesc )
{
	D3DXMATRIXA16 matWorld;
	D3DXMatrixIdentity( &matWorld );
	pd3dDevice->SetTransform( D3DTS_WORLD, &matWorld );

	D3DXVECTOR3 vEyePt( 0.0f, 0.0f,-1.0f );
    D3DXVECTOR3 vLookatPt( 0.0f, 0.0f, 0.0f );
    D3DXVECTOR3 vUpVec( 0.0f, 1.0f, 0.0f );
    D3DXMATRIXA16 matView;
    D3DXMatrixLookAtLH( &matView, &vEyePt, &vLookatPt, &vUpVec );
    pd3dDevice->SetTransform( D3DTS_VIEW, &matView );

	D3DXMATRIXA16 matProj;
	D3DXMatrixOrthoOffCenterLH( &matProj, -1.0f, 1.0f, -1.0f, 1.0f, -1.0f, 1.0f );
	pd3dDevice->SetTransform( D3DTS_PROJECTION, &matProj );

	pd3dDevice->SetRenderState( D3DRS_AMBIENT, 0xffffffff );

	CMMTexture* t_texture = Textures::GetTextureManager()->CreateTextureObject( TEXTURE_SIMPLE );
	t_texture->LoadTexture( pd3dDevice, L"Particle32bit.tga" );
//	g_ps->Reset( pd3dDevice, 1, 1.0f, InitParticle, UpdateParticle, IsParticleAlive, t_texture, false );
	Ship->LoadMesh( pd3dDevice, L"ship.x" );

	D3DXMATRIXA16 matTmp;
	D3DXMatrixScaling( &matTmp, 0.25f / Ship->GetMeshRadius(),
		0.25f / Ship->GetMeshRadius(),
		0.25f / Ship->GetMeshRadius() );
	Ship->SetScaling( matTmp );
	D3DXMatrixTranslation( &matTmp, -0.90f, 0.0f, 0.0f );
	Ship->SetTranslation( matTmp );

	pd3dDevice->SetRenderState( D3DRS_ZENABLE, D3DZB_FALSE );
	pd3dDevice->SetRenderState( D3DRS_CULLMODE, D3DCULL_NONE );

    return S_OK;
}

void CALLBACK KeyboardProc( UINT nChar, bool bKeyDown, bool bAltDown )
{
	D3DXMATRIXA16 mat;
    if( bKeyDown )
    {
		mat = D3DXMATRIXA16(Ship->GetTranslation());
        switch( nChar )
        {
            case VK_LEFT:
				mat._41 -= 0.01f;
				if(mat._41 < -0.9f)mat._41 = -0.9f;
				break;

			case VK_RIGHT:
				mat._41 += 0.01f;
				if(mat._41 > 0.7f)mat._41 = 0.7f;
				break;

			case VK_UP:
				mat._42 += 0.01f;
				if(mat._42 > 0.9f)mat._42 = 0.9f;
				break;

			case VK_DOWN:
				mat._42 -= 0.01f;
				if(mat._42 < -0.9f)mat._42 = -0.9f;
				break;
        }
		Ship->SetTranslation( mat );
    }
}