#ifndef _MESHOBJECT_H_INCLUDED_
#define _MESHOBJECT_H_INCLUDED_

#include "global.h"
#include <string>
#include <d3dx9.h>
#include "mmobject.h"
#include "textureobject.h"

enum MeshTypes
{
	MESH_SIMPLE
};

class CMMMesh : public CMMObject
{
public:
	CMMMesh() : CMMObject(), 
		mesh( NULL ), filename( L"" ), materials( NULL ), textures( NULL ),
		nummaterials( 0 ), meshcenter( 0, 0, 0 ), meshradius( 0.0f ) {};
	CMMMesh( LPWSTR NAME, int TAG ) : CMMObject( NAME, TAG ),
		mesh( NULL ), filename( L"" ), materials( NULL ), textures( NULL ),
		nummaterials( 0 ), meshcenter( 0, 0, 0 ), meshradius( 0.0f ) {};
	virtual ~CMMMesh() { CleanUp (); };
	virtual void CleanUp();
	virtual HRESULT LoadMesh( LPDIRECT3DDEVICE9 DEVICE, LPWSTR FILENAME );
	virtual void DrawMesh( LPDIRECT3DDEVICE9 DEVICE );
	virtual LPD3DXMESH GetMesh();
	virtual D3DXVECTOR3 GetMeshCenter();
	virtual float GetMeshRadius();
	virtual std::wstring GetMeshFileName();
	virtual D3DMATRIX GetMatrix();
	virtual void SetTranslation( D3DMATRIX TRANSLATION );
	virtual D3DMATRIX GetTranslation();
	virtual void SetRotation( D3DMATRIX ROTATION );
	virtual D3DMATRIX GetRotation();
	virtual void SetScaling( D3DMATRIX SCALING );
	virtual D3DMATRIX GetScaling();

protected:
	LPD3DXMESH mesh;
	std::wstring filename;
	D3DMATERIAL9* materials;
	CMMTexture** textures;
	DWORD nummaterials;
	D3DXVECTOR3 meshcenter;
	float meshradius;
	D3DXMATRIXA16 matrix;
	D3DXMATRIXA16 translation;
	D3DXMATRIXA16 rotation;
	D3DXMATRIXA16 scaling;

	void SetupMatrix();
};

#endif // #ifndef _MESHOBJECT_H_INCLUDED_