#ifndef _MMOBJECT_H_INCLUDED_
#define _MMOBJECT_H_INCLUDED_

#include "global.h"
#include <string>

class CMMObject
{
public:
	CMMObject() : refcount( 1 ), tag( 0 ), name( L"" ) {};
	CMMObject( LPWSTR NAME, int TAG ) : refcount( 1 ), tag( TAG ), name( NAME ) {};
	virtual ~CMMObject() { CleanUp (); };
	virtual void CleanUp() {};
	virtual void AddRef();
	virtual void Release();
	virtual CMMObject* GetObject();
	virtual int GetRefCount();
	virtual void SetName( LPWSTR NAME );
	virtual std::wstring GetName();
	virtual void SetTag( int TAG );
	virtual int GetTag();

protected:
	int refcount;
	int tag;
	std::wstring name;
};

#endif // #ifndef _MMOBJECT_H_INCLUDED_