#ifndef _PARTICLEOBJECT_H_INCLUDED_
#define _PARTICLEOBJECT_H_INCLUDED_

#include "global.h"
#include <d3dx9.h>
#include "mmobject.h"

struct PARTICLEVERTEX
{
	D3DXVECTOR3 position;
	D3DCOLOR	color;
	D3DXVECTOR2 tex1;
};

#define D3DFVF_PARTICLEVERTEX (D3DFVF_XYZ | D3DFVF_DIFFUSE | D3DFVF_TEX1)

class CMMParticle : public CMMObject
{
public:
	CMMParticle() : CMMObject(), color( 0.0f, 0.0f, 0.0f, 0.0f ),
		colordecay( 0.0f, 0.0f, 0.0f, 0.0f ), position( 0.0f, 0.0f, 0.0f ),
		speed( 0.0f, 0.0f, 0.0f ), accel( 0.0f, 0.0f, 0.0f ) {};
	CMMParticle( LPWSTR NAME, int TAG ) : CMMObject( NAME, TAG ),
		color( 0.0f, 0.0f, 0.0f, 0.0f ),
		colordecay( 0.0f, 0.0f, 0.0f, 0.0f ), position( 0.0f, 0.0f, 0.0f ),
		speed( 0.0f, 0.0f, 0.0f ), accel( 0.0f, 0.0f, 0.0f ) {};
	virtual D3DXVECTOR3 GetPosition();
	virtual void SetPosition( D3DXVECTOR3 POSITION );
	virtual D3DXCOLOR GetColor();
	virtual void SetColor( D3DXCOLOR COLOR );
	virtual D3DXVECTOR3 GetSpeed();
	virtual void SetSpeed( D3DXVECTOR3 SPEED );
	virtual D3DXVECTOR3 GetAcceleration();
	virtual void SetAcceleration( D3DXVECTOR3 ACCEL );
	virtual D3DXCOLOR GetColorDecay();
	virtual void SetColorDecay( D3DXCOLOR COLORDECAY );
protected:
	D3DXVECTOR3 position; // pozicija
	D3DXCOLOR color; // boja
	D3DXVECTOR3 speed; // brzina
	D3DXVECTOR3 accel; // ubrzanje (za svaki korak speed+=accel)
	D3DXCOLOR colordecay; // promena boje (za svaki korak color+=colordecay)
	//mozda treba dodati i texturu za svaki particle, ali mislim da grupa
	//srodnih cestica u jednom sistemu koriste istu texturu tako da cu podatke
	//o texturi drzati u klasi za skup cestica
};

#endif // #ifndef _PARTICLEOBJECT_H_INCLUDED_